/*  P A S - P. WOLFERS SOFTWARE: V3.0-A OF 31-OCT-2014 
  ***  PASCAL II implementation in C. *** */

/* Set specific Macro setting. */
#define CC_TYPE_SW short
#define CC_TYPE_SL   int
#define CC_TYPE_SQ  long
#include <draw/draw_apientry.h>

/* Include the PAS environment file. */
#include "/usr/local/cpas/cpas_defs.h"

/* Define the local data section. */
static Blk( Rd, 344 ) = {
  9,   9,  97, 114, 114, 111, 119,  95, 115, 101, 103,  67,  67,  47, 104, 111,
109, 101,  47, 112, 105, 101, 114, 114, 101,  47,  83, 111, 102, 116,  47,  68,
114,  97, 119,  95,  70,  76,  84,  75,  95, 115, 114,  99,  95,  86,  49,  46,
 53,  67,  45,  98,  97, 115, 101,  47,  68, 114,  97, 119,  95,  69, 120,  97,
109, 112, 108, 101, 115,  47,  47, 101, 115, 105, 110,  99,  46, 112,  97, 115,
  5,   5,  97, 114, 114, 111, 119,  15,  15, 100, 105, 115, 112, 108,  97, 121,
 95, 115, 117, 114, 102,  97,  99, 101,   0,   0,  72,  66,   0,   0,   0,   0,
  0,   0,  72,  66, 154, 153,  25,  63, 154, 153,  25,  63, 154, 153,  25,  63,
  0,   0, 128,  63,   0,   0, 128,  63,   0,   0, 128,  63,   0,   0, 128,  63,
  0,   0, 128,  63,   0,   0, 128,  63,   0,   0, 128,  63,   0,   0, 128,  63,
  0,   0, 128,  63,   0,   0, 200,  66,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0, 128,  63,  17,  17, 101, 115, 115,  97, 105,  95,
115, 121, 115,  95, 105, 110,  99, 108, 117, 100, 101,  13,  13,  69, 115, 115,
 97, 105,  32,  71, 114,  97, 112, 104, 105,  99,   5,   5, 120, 115,  32,  61,
 32,   8,   8,  32,  32,  32, 121, 115,  32,  61,  32,  10,  10,  32,  32,  32,
117, 110, 105, 116,  32,  61,  32,  16,  16,  32,  67, 111, 109, 112, 108, 101,
120,  32,  79,  98, 106, 101,  99, 116, 115,  10,  10,  32,  83, 116,  97, 116,
117, 115,  32,  61,  32,  14,  14,  32,  80, 105,  99, 107,  32, 111, 102,  32,
115, 101, 103,  32,  35,  16,  16,  32, 119, 105, 116, 104,  32, 112, 105,  99,
107,  95, 105, 100,  32,  61,  32,  27,  27,  32,  70, 105, 110,  32,  69, 115,
115,  97, 105,  32,  73, 110,  99, 108, 117, 100, 101,  32,  79,  98, 106, 101,
 99, 116, 115,  46,   0,   0,   0,   0
};

/* Define the local static Initialized section. */
static Blk( Ri, 40 ) = {
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0
};

/* Define the local static section. */
static Blk( Rs, 40 );

/* Declaration of external variables. */
extern V PAS__f_output;
extern SL Draw_SrvMod;


/* Function/procedure prototypes. */
void Draw_End();
UB Draw_Pas_Init(F *F_x, F *F_y, UB *F_unit, V F_usrid);
UB Draw_Pas_Picture_3D(V F_title, F F_px, F F_py, F F_pz, UB F_bscale, UB F_blimit)
;
SL Draw_Dialog(SL F_flags);
void Draw_Plot3(F F_x, F F_y, F F_z, UB F_ipen);
void Draw_Sphere(F F_xc, F F_yc, F F_zc, F F_r, SL F_plg, SL F_plt, SL F_flg);
void Draw_Cylinder(F F_xb, F F_yb, F F_zb, F F_th, F F_ph, F F_lg, F F_rb, F F_rt
, SL F_px, SL F_pz, SL F_flg);
void Draw_Disk(F F_xc, F F_yc, F F_zc, F F_th, F F_ph, F F_ri, F F_re, F F_sa, F
F_ea, SL F_pt, SL F_pr, SL F_flg);
void Draw_Color_Index(SL F_n);
void Draw_Set_ColorA(F F_r, F F_v, F F_b, F F_a);
SL Draw_Seg_Pick(SL *F_seg_id, SL *F_pick_id);
SL Draw_New_Seg(SL F_n);
void Draw_Seg_End();
void Draw_Include_Seg(SL F_n);
void Draw_Seg_Attr(SL F_seg_id, SL F_det, SL F_hli, SL F_vis, F F_prior);
void Draw_Set_Pickid(SL F_pic_id);
SL Draw_Detectable(SL F_det_flg);
SL Draw_Push_Matrix();
void Draw_Pop_Matrix();
void Draw_Move_Seg3(SL F_iseg, F F_tx, F F_ty, F F_tz);
void Draw_Move_Mat3(SL F_imat, F F_tx, F F_ty, F F_tz);
void Draw_Rotate_Seg3(SL F_iseg, F F_px, F F_py, F F_pz, F F_ome, F F_chi, F F_psi)
;
void Draw_Rotate_Mat3(SL F_imat, F F_px, F F_py, F F_pz, F F_ome, F F_chi, F F_psi)
;
SL Draw_Get_Seg_Mat(SL F_iseg, V F_m);
void Draw_Light_Define(SL F_light, SL F_kind, V F_fparm, SL F_sz);
void Draw_Mat_Light_Prop(SL F_face, SL F_kind, V F_fparm, SL F_sz);
void Draw_View(F F_dist);


/* Procedure/Function : " arrow_seg "  */
SL ESSAI_SLUDE_arrow_seg(F F_m, F F_rd, UB F_flg){
  /* Define the automatic variable space. */
  Blk( Ra, 32 );

  /* Local variable stored in C variable */
  SL Rv0;
  F Rv1;
  F Rv2;
  F Rv3;
  F Rv4;
  F Rv5;
  F Rv6;
  register SL Ret;

  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s;
  Ra.v[2]=Rd.s+11;
  Ra.sl[6]=46; /* line # 46 */
  Rv0=Draw_New_Seg(-1);
  Ra.sl[6]=47; /* line # 47 */
  if (F_flg) {
    Ra.sl[6]=49; /* line # 49 */
    Rv1=F_rd;
    Rv2=(F)3.000000E-01*Rv1;
    Rv3=Rv2;
    Ra.sl[6]=50; /* line # 50 */
    Rv4=(F)0.000000E-01;
    Rv5=F_m;
    Rv6=F_m-(F)5.000000E-01;
    Ra.sl[6]=51; /* line # 51 */
    Draw_Set_Pickid(0);
  }
  else {
    Ra.sl[6]=55; /* line # 55 */
    Rv2=F_rd;
    Rv3=Rv2*(F)5.714286E-01;
    Rv1=Rv2*(F)1.285714E+00;
    Ra.sl[6]=56; /* line # 56 */
    Rv5=F_m*(F)5.000000E-01;
    Rv4= -Rv5;
    Rv6=(F)6.000000E-01*Rv5;
  }
  Ra.sl[6]=58; /* line # 58 */
  Draw_Seg_Attr(Rv0,0,0,0, (F)0.000000E-01);
  Ra.sl[6]=59; /* line # 59 */
  if (!F_flg) Draw_Set_Pickid(1);
  Ra.sl[6]=60; /* line # 60 */
  Draw_Disk((F)0.000000E-01, (F)0.000000E-01, Rv4, (F)1.800000E+02, (F)0.000000E-01,
  (F)0.000000E-01, Rv2, (F)0.000000E-01, (F)3.600000E+02,32,8,4);
  Ra.sl[6]=61; /* line # 61 */
  if (!F_flg) Draw_Set_Pickid(2);
  Ra.sl[6]=62; /* line # 62 */
  Draw_Cylinder((F)0.000000E-01, (F)0.000000E-01, Rv4, (F)0.000000E-01, (F)0.000000E-01,
  Rv6-Rv4, Rv2, Rv3,32,8,4);
  Ra.sl[6]=63; /* line # 63 */
  if (!F_flg) Draw_Set_Pickid(3);
  Ra.sl[6]=64; /* line # 64 */
  Draw_Disk((F)0.000000E-01, (F)0.000000E-01, Rv6, (F)1.800000E+02, (F)0.000000E-01,
  Rv3, Rv1, (F)0.000000E-01, (F)3.600000E+02,32,8,4);
  Ra.sl[6]=65; /* line # 65 */
  if (!F_flg) Draw_Set_Pickid(4);
  Ra.sl[6]=66; /* line # 66 */
  Draw_Cylinder((F)0.000000E-01, (F)0.000000E-01, Rv6, (F)0.000000E-01, (F)0.000000E-01,
  Rv5-Rv6, Rv1, (F)0.000000E-01,32,8,4);
  Ra.sl[6]=67; /* line # 67 */
  Draw_Seg_End();
  Ra.sl[6]=68; /* line # 68 */
  Ret=Rv0;
  PAS__curr_cntx=Ra.v[0];
  return(Ret);
}


/* Procedure/Function : " arrow "  */
SL ESSAI_SLUDE_arrow(SL F_imom, F F_x, F F_y, F F_z, F F_th, F F_ph){
  /* Define the automatic variable space. */
  Blk( Ra, 32 );

  /* Local variable stored in C variable */
  SL Rv0;
  register SL Ret;

  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s+80;
  Ra.v[2]=Rd.s+11;
  Ra.sl[6]=77; /* line # 77 */
  Rv0=Draw_Push_Matrix();
  Ra.sl[6]=78; /* line # 78 */
  Draw_Move_Mat3(Rv0, F_x, F_y, F_z);
  Ra.sl[6]=79; /* line # 79 */
  Draw_Rotate_Mat3(Rv0, (F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01, F_ph,
  F_th, (F)0.000000E-01);
  Ra.sl[6]=80; /* line # 80 */
  Draw_Include_Seg(F_imom);
  Ra.sl[6]=81; /* line # 81 */
  Draw_Pop_Matrix();
  Ra.sl[6]=82; /* line # 82 */
  Ret=Rv0;
  PAS__curr_cntx=Ra.v[0];
  return(Ret);
}


/* Procedure/Function : " display_surface "  */
void ESSAI_SLUDE_display_surface(){
  /* Define the automatic variable space. */
  Blk( Ra, 80 );

  /* Local variable stored in C variable */
  SL Rv0;
  SL Rv1;
  register int Rf1, Rf0;

  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s+87;
  Ra.v[2]=Rd.s+11;
  Ra.sl[6]=119; /* line # 119 */
  Ri.sl[0]=ESSAI_SLUDE_arrow_seg((F)1.200000E+01, (F)2.000000E-01,1);
  Ra.sl[6]=120; /* line # 120 */
  Ri.sl[1]=ESSAI_SLUDE_arrow_seg((F)1.600000E+01, (F)2.000000E-01,1);
  Ra.sl[6]=121; /* line # 121 */
  Ri.sl[2]=ESSAI_SLUDE_arrow_seg((F)5.000000E+00, (F)3.500000E-01,0);
  Ra.sl[6]=123; /* line # 123 */
  Ri.sl[3]=Draw_New_Seg(-1);
  Ra.sl[6]=124; /* line # 124 */
  Draw_Seg_Attr(Ri.sl[3],2,0,2, (F)5.000000E-01);
  Ra.sl[6]=125; /* line # 125 */
  Draw_Rotate_Seg3(Ri.sl[3],(F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01, (F)
9.000000E+01, (F)8.000000E+01, (F)-8.000000E+01);
  Ra.sl[6]=127; /* line # 127 */
  Draw_Move_Seg3(Ri.sl[3],(F)-8.000000E+00, (F)-8.000000E+00, (F)-8.000000E+00);
  Ra.sl[6]=131; /* line # 131 */
  Draw_Get_Seg_Mat(Ri.sl[3],Ra.s+28);
  Ra.sl[6]=132; /* line # 132 */
  Rv0=1;
  for( Rf1=3;Rf1>0;Rf1-- ) {
    Ra.sl[6]=134; /* line # 134 */
    Rv1=1;
    for( Rf0=4;Rf0>0;Rf0-- ) {
      Ra.sl[6]=135; /* line # 135 */
      PAS__SELECT_OUT(PAS__f_output);
      PAS__WRITE_SNGL(Ra.f[Rv0*4+Rv1+2],12,2,0);
      Rv1++;
    }
    Ra.sl[6]=136; /* line # 136 */
    PAS__SELECT_OUT(PAS__f_output);
    PAS__WRITE_EOLN();
    Rv0++;
  }
  Ra.sl[6]=138; /* line # 138 */
  PAS__SELECT_OUT(PAS__f_output);
  PAS__WRITE_EOLN();
  Ra.sl[6]=149; /* line # 149 */
  Draw_Light_Define(1,0, Rd.s+104,3);
  Ra.sl[6]=150; /* line # 150 */
  Draw_Light_Define(1,1, Rd.s+116,4);
  Ra.sl[6]=151; /* line # 151 */
  Draw_Light_Define(1,2, Rd.s+132,4);
  Ra.sl[6]=152; /* line # 152 */
  Draw_Light_Define(1,3, Rd.s+148,4);
  Ra.sl[6]=154; /* line # 154 */
  Draw_Mat_Light_Prop(0,4, Rd.s+164,1);
  Ra.sl[6]=155; /* line # 155 */
  Draw_Mat_Light_Prop(0,5, Rd.s+168,4);
  Ra.sl[6]=157; /* line # 157 */
  Draw_View((F)0.000000E-01);
  Ra.sl[6]=159; /* line # 159 */
  Rs.f[0]=(F)9.000000E+01;
  Rs.f[1]=(F)0.000000E-01;
  Ra.sl[6]=162; /* line # 162 */
  Draw_Set_Pickid(1000);
  Ra.sl[6]=163; /* line # 163 */
  Draw_Detectable(0);
  Ra.sl[6]=165; /* line # 165 */
  Draw_Set_ColorA((F)7.000000E-01, (F)0.000000E-01, (F)0.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=166; /* line # 166 */
  Ri.sl[4]=ESSAI_SLUDE_arrow(Ri.sl[0],(F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01,
  (F)9.000000E+01, (F)0.000000E-01);
  Ra.sl[6]=167; /* line # 167 */
  Draw_Set_ColorA((F)0.000000E-01, (F)7.000000E-01, (F)0.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=168; /* line # 168 */
  Ri.sl[5]=ESSAI_SLUDE_arrow(Ri.sl[0],(F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01,
  (F)9.000000E+01, (F)9.000000E+01);
  Ra.sl[6]=169; /* line # 169 */
  Draw_Set_ColorA((F)0.000000E-01, (F)0.000000E-01, (F)7.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=170; /* line # 170 */
  Ri.sl[6]=ESSAI_SLUDE_arrow(Ri.sl[1],(F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01,
  (F)0.000000E-01, (F)0.000000E-01);
  Ra.sl[6]=172; /* line # 172 */
  Draw_Color_Index(1);
  Ra.sl[6]=173; /* line # 173 */
  Draw_Plot3((F)1.200000E+01, (F)0.000000E-01, (F)0.000000E-01,0);
  Ra.sl[6]=174; /* line # 174 */
  Draw_Plot3((F)1.200000E+01, (F)1.200000E+01, (F)0.000000E-01,1);
  Ra.sl[6]=175; /* line # 175 */
  Draw_Plot3((F)0.000000E-01, (F)1.200000E+01, (F)0.000000E-01,1);
  Ra.sl[6]=176; /* line # 176 */
  Draw_Plot3((F)0.000000E-01, (F)0.000000E-01, (F)1.600000E+01,0);
  Ra.sl[6]=177; /* line # 177 */
  Draw_Plot3((F)1.200000E+01, (F)0.000000E-01, (F)1.600000E+01,1);
  Ra.sl[6]=178; /* line # 178 */
  Draw_Plot3((F)1.200000E+01, (F)1.200000E+01, (F)1.600000E+01,1);
  Ra.sl[6]=179; /* line # 179 */
  Draw_Plot3((F)0.000000E-01, (F)1.200000E+01, (F)1.600000E+01,1);
  Ra.sl[6]=180; /* line # 180 */
  Draw_Plot3((F)0.000000E-01, (F)1.200000E+01, (F)1.600000E+01,1);
  Ra.sl[6]=181; /* line # 181 */
  Draw_Plot3((F)0.000000E-01, (F)0.000000E-01, (F)1.600000E+01,1);
  Ra.sl[6]=182; /* line # 182 */
  Draw_Plot3((F)1.200000E+01, (F)0.000000E-01, (F)1.600000E+01,0);
  Ra.sl[6]=183; /* line # 183 */
  Draw_Plot3((F)1.200000E+01, (F)0.000000E-01, (F)0.000000E-01,1);
  Ra.sl[6]=184; /* line # 184 */
  Draw_Plot3((F)1.200000E+01, (F)1.200000E+01, (F)1.600000E+01,0);
  Ra.sl[6]=185; /* line # 185 */
  Draw_Plot3((F)1.200000E+01, (F)1.200000E+01, (F)0.000000E-01,1);
  Ra.sl[6]=186; /* line # 186 */
  Draw_Plot3((F)0.000000E-01, (F)1.200000E+01, (F)1.600000E+01,0);
  Ra.sl[6]=187; /* line # 187 */
  Draw_Plot3((F)0.000000E-01, (F)1.200000E+01, (F)0.000000E-01,1);
  Ra.sl[6]=188; /* line # 188 */
  Draw_Plot3((F)0.000000E-01, (F)0.000000E-01, (F)0.000000E-01,0);
  Ra.sl[6]=190; /* line # 190 */
  Draw_Detectable(1);
  Ra.sl[6]=195; /* line # 195 */
  Draw_Set_Pickid(10);
  Ra.sl[6]=196; /* line # 196 */
  Draw_Set_ColorA((F)2.000000E-01, (F)6.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=197; /* line # 197 */
  Ri.sl[7]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)8.000000E+00, (F)8.000000E+00, (F)0.000000E-01,
  (F)2.200000E+01, (F)4.500000E+01);
  Ra.sl[6]=198; /* line # 198 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=199; /* line # 199 */
  Draw_Set_Pickid(19);
  Ra.sl[6]=200; /* line # 200 */
  Draw_Sphere((F)8.000000E+00, (F)8.000000E+00, (F)0.000000E-01, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=202; /* line # 202 */
  Draw_Set_Pickid(20);
  Ra.sl[6]=203; /* line # 203 */
  Draw_Set_ColorA((F)2.000000E-01, (F)2.000000E-01, (F)6.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=204; /* line # 204 */
  Ri.sl[8]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)4.000000E+00, (F)4.000000E+00, (F)0.000000E-01,
  (F)4.800000E+01, (F)4.500000E+01);
  Ra.sl[6]=205; /* line # 205 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=206; /* line # 206 */
  Draw_Set_Pickid(29);
  Ra.sl[6]=207; /* line # 207 */
  Draw_Sphere((F)4.000000E+00, (F)4.000000E+00, (F)0.000000E-01, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=210; /* line # 210 */
  Draw_Set_Pickid(30);
  Ra.sl[6]=211; /* line # 211 */
  Draw_Set_ColorA((F)2.000000E-01, (F)6.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=212; /* line # 212 */
  Ri.sl[7]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)2.000000E+00, (F)1.000000E+01, (F)8.000000E+00,
  (F)3.500000E+01, (F)2.500000E+01);
  Ra.sl[6]=213; /* line # 213 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=214; /* line # 214 */
  Draw_Set_Pickid(39);
  Ra.sl[6]=215; /* line # 215 */
  Draw_Sphere((F)2.000000E+00, (F)1.000000E+01, (F)8.000000E+00, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=217; /* line # 217 */
  Draw_Set_Pickid(40);
  Ra.sl[6]=218; /* line # 218 */
  Draw_Set_ColorA((F)2.000000E-01, (F)2.000000E-01, (F)6.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=219; /* line # 219 */
  Ri.sl[8]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)1.000000E+01, (F)2.000000E+00, (F)8.000000E+00,
  (F)3.500000E+01, (F)6.500000E+01);
  Ra.sl[6]=220; /* line # 220 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=221; /* line # 221 */
  Draw_Set_Pickid(49);
  Ra.sl[6]=222; /* line # 222 */
  Draw_Sphere((F)1.000000E+01, (F)2.000000E+00, (F)8.000000E+00, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=225; /* line # 225 */
  Draw_Set_Pickid(50);
  Ra.sl[6]=226; /* line # 226 */
  Draw_Set_ColorA((F)2.000000E-01, (F)6.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=227; /* line # 227 */
  Ri.sl[7]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)8.000000E+00, (F)8.000000E+00, (F)1.600000E+01,
  (F)2.200000E+01, (F)4.500000E+01);
  Ra.sl[6]=228; /* line # 228 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=229; /* line # 229 */
  Draw_Set_Pickid(59);
  Ra.sl[6]=230; /* line # 230 */
  Draw_Sphere((F)8.000000E+00, (F)8.000000E+00, (F)1.600000E+01, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=232; /* line # 232 */
  Draw_Set_Pickid(60);
  Ra.sl[6]=233; /* line # 233 */
  Draw_Set_ColorA((F)2.000000E-01, (F)2.000000E-01, (F)6.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=234; /* line # 234 */
  Ri.sl[8]=ESSAI_SLUDE_arrow(Ri.sl[2],(F)4.000000E+00, (F)4.000000E+00, (F)1.600000E+01,
  (F)4.800000E+01, (F)4.500000E+01);
  Ra.sl[6]=235; /* line # 235 */
  Draw_Set_ColorA((F)8.000000E-01, (F)5.000000E-01, (F)2.000000E-01, (F)1.000000E+00);
  Ra.sl[6]=236; /* line # 236 */
  Draw_Set_Pickid(69);
  Ra.sl[6]=237; /* line # 237 */
  Draw_Sphere((F)4.000000E+00, (F)4.000000E+00, (F)1.600000E+01, (F)7.000000E-01,32,32,4);
  Ra.sl[6]=239; /* line # 239 */
  Draw_Seg_End();
  PAS__curr_cntx=Ra.v[0];
}


/* Procedure/Function : " essai_sys_include "  */
main( int argc, C * argv[], C * env[] ) {
  /* Local variable stored in C variable */
  F Rv0;
  F Rv1;
  UB Rv2;
  UB Rv3;
  SL Rv4;
  SL Rv5;
  SL Rv6;
  SL Rv7;

  /* Code of procedure/function */
  PAS__INIT( argc, argv, env );
  Rs.v[1]=PAS__curr_cntx;
  PAS__curr_cntx=Rs.s+8;
  Rs.v[2]=Rd.s+184;
  Rs.v[3]=Rd.s+11;
  Rs.sl[8]=249; /* line # 249 */
  Draw_SrvMod=16;
  Rs.sl[8]=251; /* line # 251 */
  Draw_Pas_Init(&Rv0, &Rv1, &Rv2, Rd.s+203);
  Rs.sl[8]=252; /* line # 252 */
  PAS__SELECT_OUT(PAS__f_output);
  PAS__WRITE_STR(Rd.s+218,-1,-1,32);
  PAS__WRITE_SNGL(Rv0,16,-6,0);
  PAS__WRITE_STR(Rd.s+225,-1,-1,32);
  PAS__WRITE_SNGL(Rv1,16,-6,0);
  PAS__WRITE_STR(Rd.s+235,-1,-1,32);
  PAS__WRITE_INT(Rv2,12,0);
  PAS__WRITE_EOLN();
  Rs.sl[8]=254; /* line # 254 */
  Rv3=Draw_Pas_Picture_3D(Rd.s+247,(F)3.000000E+01, (F)3.000000E+01, (F)3.000000E+01,1,1);
  Rs.sl[8]=255; /* line # 255 */
  ESSAI_SLUDE_display_surface();
  while (1){
    Rs.sl[8]=258; /* line # 258 */
    Rv4=Draw_Dialog(1);
    Rs.sl[8]=259; /* line # 259 */
    if (Rv4<0)  break;
    while (1){
      Rs.sl[8]=261; /* line # 261 */
      Rv5=Draw_Seg_Pick(&Rv6, &Rv7);
      Rs.sl[8]=262; /* line # 262 */
      PAS__SELECT_OUT(PAS__f_output);
      PAS__WRITE_STR(Rd.s+265,-1,-1,32);
      PAS__WRITE_INT(Rv5,12,0);
      PAS__WRITE_STR(Rd.s+277,-1,-1,32);
      PAS__WRITE_INT(Rv6,12,0);
      PAS__WRITE_STR(Rd.s+293,-1,-1,32);
      PAS__WRITE_INT(Rv7,12,0);
      PAS__WRITE_EOLN();
      if (Rv5<0)  break;
    }
  }
  Rs.sl[8]=266; /* line # 266 */
  Draw_End();
  Rs.sl[8]=268; /* line # 268 */
  PAS__SELECT_OUT(PAS__f_output);
  PAS__WRITE_STR(Rd.s+311,-1,-1,32);
  PAS__WRITE_EOLN();
  PAS__curr_cntx=Rs.v[1];
  PAS__EXIT( 0 );
}
